package be.ggj.elektrofried.painters;

import java.awt.AlphaComposite;
import java.awt.Graphics2D;

import org.jdesktop.swingx.painter.Painter;

import be.ggj.elektrofried.sprites.Particle;

public class ParticlePainter implements Painter<Particle> {

	private int[] prevMoveX;
	private int[] prevMoveY;
	private float[] trailOpacity;

	public void paint(Graphics2D graphics, Particle sprite, int x1, int y1) {
		graphics.setColor(sprite.getColor());
		graphics.fillArc((int) Math.round(sprite.getX1()), (int) Math.round(sprite.getY1()), (int) sprite.getWidth(), (int) sprite.getHeight(), 0, 360);
		//graphics.drawRect((int) sprite.getX1(),(int) sprite.getY1(), (int) sprite.getWidth(), (int) sprite.getHeight() );
		//graphics.drawRect((int) sprite.getCenterX(), (int) sprite.getCenterY(), (int) sprite.getWidth(), (int) sprite.getHeight() );
		int blurSize = 1;
		if (prevMoveX == null) {
			// blur location array not yet created; create it now 
			prevMoveX = new int[blurSize]; 
			prevMoveY = new int[blurSize]; 
			trailOpacity = new float[blurSize];
			float incrementalFactor = .2f / (blurSize + 1); 
			for (int i = 0; i < blurSize; ++i) {
				// default values, act as flag to not render these 
				// until they have real values 
				prevMoveX[i] = -1; 
				prevMoveY[i] = -1;
				// vary the translucency by the number of the ghost 
				// image; the further away it is from the current one, 
				// the more faded it will be 
				trailOpacity[i] = (.2f - incrementalFactor) - i * incrementalFactor;
			}
		}
		for (int i = 0; i < blurSize; ++i) {
			if (prevMoveX[i] >= 0) { // Render each blur image with the appropriate
				//graphics.setComposite(AlphaComposite.SrcOver.derive(trailOpacity[i])); 
				//graphics.fillArc( prevMoveX[i], prevMoveY[i], (int) sprite.getWidth(), (int) sprite.getHeight(), 0, 360);
			}
		}
		// shift the ghost positions to add the current position // and drop the oldest one
		for (int i = blurSize - 1; i > 0; --i) {
			prevMoveX[i] = prevMoveX[i - 1]; 
			prevMoveY[i] = prevMoveY[i - 1];
		} 
		prevMoveX[0] = x1;
		prevMoveY[0] = y1;
	}


}
