package be.ggj.elektrofried.sprites;

import java.awt.Color;

import be.ggj.elektrofried.game.ElektroFriedGame;

public class Elektron extends Particle {
	
	public final static double DEFAULT_SPEED_INCREASE = 0.05;

	protected double speed;
	private double orbitRadiusX, orbitRadiusY;
	 private final double centerX, centerY;

	public Elektron(double centerX, double centerY, double orbitRadiusX, double orbitRadiusY, double speed, double radius) {
		super(radius);
		this.centerX = centerX;
		this.centerY = centerY;
		this.orbitRadiusX = orbitRadiusX;
		this.orbitRadiusY = orbitRadiusY;
		setCoordinates(0);
		this.speed = speed + Math.random() * DEFAULT_SPEED_INCREASE;
		setColor(Color.red);
	}

	public void setXCoordinate(double alpha) {
		super.setX1(getCenterX() + getOrbitRadiusX() * Math.cos(ElektroFriedGame.SPEED_MULTIPLIER * alpha * getSpeed()));
	}

	public void setYCoordinate(double alpha) {
		super.setY1(getCenterY() + getOrbitRadiusY() * Math.sin(ElektroFriedGame.SPEED_MULTIPLIER * alpha * getSpeed()));
	}
	
	
	
	public double getCenterX() {
		return centerX;
	}

	public double getCenterY() {
		return centerY;
	}
	
	public double getOrbitRadiusX() {
		return orbitRadiusX;
	}

	public double getOrbitRadiusY() {
		return orbitRadiusY;
	}
	
	public void setOrbitRadius(double radius) {
		this.orbitRadiusX = radius;
		this.orbitRadiusY = radius;
	}
	
	public void setOrbitRadiusX(double orbitRadiusX) {
		this.orbitRadiusX = orbitRadiusX;
	}

	public void setOrbitRadiusY(double orbitRadiusY) {
		this.orbitRadiusY = orbitRadiusY;
	}

	public void setCoordinates(double alpha) {
		setXCoordinate(alpha);
		setYCoordinate(alpha);
	}
	
	public void setCoordinates(double alpha, double orbitRadiusX, double orbitRadiusY) {
		setOrbitRadiusX(orbitRadiusX);
		setOrbitRadiusY(orbitRadiusY);
		setCoordinates(alpha);
	}
	
	public void setCoordinates(double alpha, double orbitRadius) {
		setOrbitRadius(orbitRadius);
		setCoordinates(alpha);
	}

	public double getSpeed() {
		return speed;
	}
	
	public void setSpeed(double speed) {
		this.speed = speed;
	}

}
