package be.ggj.elektrofried.sprites;

import java.awt.Color;
import java.util.ArrayList;
import java.util.List;

import org.jdesktop.swingx.painter.Painter;

import be.ggj.elektrofried.painters.CloudPainter;

public class ElektronCloud implements Cloud {

	private List<Particle> elektrons = new ArrayList<Particle>();

	private Painter<Cloud> painter = new CloudPainter<ElektronCloud>();

	private double centerX, centerY;

	private double speed;

	public ElektronCloud(int centerX, int centerY, int amount, double speed) {
		this.centerX = centerX;
		this.centerY = centerY;
		this.speed = speed;
		for (int i = 0; i < amount; i++) {
			addElektron(Color.red, speed);
		}
	}
	
	public void addElektron(Color color) {
		addElektron(color, getSpeed());
	}

	public void addElektron(Color color, double speed) {
		double diff1, diff2;
		if (getParticleAmount() % 2 == 1) {
			diff1 = 50 + 200 * Math.random();
			diff2 = 100 * Math.random();
		} else {
			diff1 = 100 * Math.random();
			diff2 = 50 + 200 * Math.random();
		}
		Elektron e = new Elektron(centerX, centerY, 100 + diff2, 100 + diff1, speed, 5);
		e.setColor(color);
		elektrons.add(e);
	}

	public double getSpeed() {
		return this.speed;
	}

	public boolean checkCollision(Particle sprite) {
		boolean result = false;
		for (Particle particle : getParticles()) {
			result |= particle.checkCollision(sprite);
		}
		return result;
	}

	public Painter<Cloud> getPainter() {
		return painter;
	}

	public void setPainter(Painter<Cloud> painter) {
		this.painter = painter;
	}

	@Override
	public double getX1() {
		return centerX;
	}

	@Override
	public double getY1() {
		return centerY;
	}

	@Override
	public double getWidth() {
		// TODO Auto-generated method stub
		return 0;
	}

	@Override
	public double getHeight() {
		// TODO Auto-generated method stub
		return 0;
	}

	public List<Particle> getParticles() {
		return elektrons;
	}
	
	public int getParticleAmount() {
		return getParticles().size();
	}

}
