package be.ggj.elektrofried.sprites;

import java.awt.Color;

import org.jdesktop.swingx.painter.Painter;

import be.ggj.elektrofried.painters.ParticlePainter;

public class Particle implements Sprite<Particle> {
	
	private double x1, y1;
	
	private double radius;
	
	private Color color;
	
	private Painter<Particle> painter = new ParticlePainter();
	
//	public Particle(int x1, int y1, int x2, int y2, int mass) {
//		rectangle = new Rectangle(x1, y1, Math.abs(x2 - x1), Math.abs(y2 - y1));
//		this.mass = mass;
//	}
	
	protected Particle(double radius) {
		setRadius(radius);
	}
	
	public Particle(double x1, double y1, double radius) {
		this(radius);
		setX1(x1 - radius);
		setY1(y1 - radius);
		setColor(Color.black);
	}

	public double getX1() {
		return x1;
	}

	public double getY1() {
		return y1;
	}
	
	public double getCenterX() {
		return x1 + getRadius();
	}
	
	public double getCenterY() {
		return y1 + getRadius();
	}
	
	public double getWidth() {
		return getRadius() * 2;
	}
	
	public double getHeight() {
		return getRadius() * 2;
	}
	
	public Painter<Particle> getPainter() {
		return painter;
	}

	public void setPainter(Painter<Particle> painter) {
		this.painter = painter;
	}

	public Color getColor() {
		return color;
	}

	public void setColor(Color color) {
		this.color = color;
	}

	public double getRadius() {
		return this.radius;
	}
	
	public void setRadius(double radius)  {
		this.radius = radius;
	}

	public void setY1(double d) {
		y1 = d;
	}

	public void setX1(double d) {
		x1 = d;
	}
	
	public boolean checkCollision(Particle particle) {
		double d1 = (getX1() + getRadius()) - (particle.getX1() + particle.getRadius());
		double d2 = (getY1() + getRadius()) - (particle.getY1() + particle.getRadius());
		double d = Math.sqrt(d1 * d1 + d2 * d2);
		double distance = getRadius() + particle.getRadius();
		return d < distance; 
	}

}
