package be.ggj.elektrofried;

import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.Toolkit;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;

import javax.swing.DefaultBoundedRangeModel;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.JSlider;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;

import org.jdesktop.animation.timing.Animator;
import org.jdesktop.application.Application;
import org.jdesktop.application.SingleFrameApplication;

import be.ggj.elektrofried.game.ElektroFriedGame;
import be.ggj.elektrofried.game.ElektroFriedGlassPane;
import be.ggj.elektrofried.io.SerialPortTest;

public class ElektroFriedApp extends SingleFrameApplication  {

	public static final String APPLICATION_NAME = "ElektroFried";
	public static final String APPLICATION_VERSION = "0.1";

	public static final int SHOCK_BUTTON_STRENGTH = 1;

	private SerialPortTest test;

	public static void main (String[] args) {
		launch(ElektroFriedApp.class, args);
	}

	/**
	 * A convenient static getter for the application instance.
	 * @return the instance of RunwalkVideoApp
	 */
	public static ElektroFriedApp getApplication() {
		return Application.getInstance(ElektroFriedApp.class);
	}

	protected void startup() {
		Dimension size =  Toolkit.getDefaultToolkit().getScreenSize();
		JFrame frame = new JFrame(APPLICATION_NAME);
		frame.setLayout(new BorderLayout());
		frame.setMinimumSize(new Dimension(size.width, size.height - 100));
		final ElektroFriedGame game = new ElektroFriedGame(1);
		final ElektroFriedGlassPane glassPane = new ElektroFriedGlassPane();
		game.addPropertyChangeListener(glassPane);
		frame.setGlassPane(glassPane);
		glassPane.setVisible(true);
		frame.add(game);
		frame.setVisible(true);
		frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		final JSlider slider = new JSlider(new DefaultBoundedRangeModel(1,  1,  1,  5));
		slider.setSnapToTicks(true);
		slider.setPaintTicks(true);
		slider.setPaintLabels(true);
		JButton startButton = new JButton("start");
		startButton.addActionListener(new ActionListener() {

			@Override
			public void actionPerformed(ActionEvent e) {
				for (Animator animator : game.getAnimators()) {
					if (!animator.isRunning()) {
						animator.start();
					}
				}
			}

		});
		JButton shockButton = new JButton("shock");
		shockButton.addActionListener(new ActionListener() {

			public void actionPerformed(ActionEvent e) {
				shock(slider.getValue());
			}

		});
		JButton elektronButton = new JButton("add electron");
		elektronButton.addActionListener(new ActionListener() {

			@Override
			public void actionPerformed(ActionEvent e) {
				game.addElectron();
			}

		});

		frame.add(game, BorderLayout.CENTER);
		JPanel southPanel = new JPanel();
		southPanel.add(startButton);
		southPanel.add(slider);
		southPanel.add(shockButton);
		southPanel.add(elektronButton);
		frame.add(southPanel, BorderLayout.SOUTH);

		frame.validate();
		test = new SerialPortTest();
		game.addPropertyChangeListener(test);
		test.initialize();
		game.startNextLevel();

		glassPane.addMouseListener(new MouseAdapter() {

			@Override
			public void mouseClicked(MouseEvent e) {
				if (glassPane.isVisible()) {
					for (Animator animator : game.getAnimators()) {
						if (!animator.isRunning()) {
							animator.start();
						}
					}				
					glassPane.setVisible(false);
				}
			}

			});
		}

		public void shock(int strength) {
			test.shock(strength);
		}

	}
